/*
*/

/* $Id: header,v 1.16.2.1 2006/01/01 12:50:00 sniper Exp $ */

#ifndef PHP_CRAPI_H
#define PHP_CRAPI_H

#define PHP_CRAPI_VERSION "0.1.0"

extern zend_module_entry crapi_module_entry;
#define phpext_crapi_ptr &crapi_module_entry

#ifdef PHP_WIN32
#define PHP_CRAPI __declspec(dllexport)
#else
#define PHP_CRAPI
#endif

#ifdef ZTS
#include "TSRM.h"
#endif

PHP_MINIT_FUNCTION(crapi);
PHP_MSHUTDOWN_FUNCTION(crapi);
PHP_MINFO_FUNCTION(crapi);

PHP_METHOD(RepositoryISO8601, parse);
PHP_METHOD(RepositoryISO8601, format);
PHP_METHOD(RepositoryOnParentVersionAction, __construct);
PHP_METHOD(RepositoryOnParentVersionAction, nameFromValue);
PHP_METHOD(RepositoryOnParentVersionAction, valueFromName);
PHP_METHOD(RepositoryPropertyType, nameFromValue);
PHP_METHOD(RepositoryPropertyType, valueFromName);
PHP_METHOD(RepositoryException, __construct);
PHP_METHOD(RepositorySimpleCredentials, __construct);
PHP_METHOD(RepositorySimpleCredentials, getPassword);
PHP_METHOD(RepositorySimpleCredentials, getUserId);
PHP_METHOD(RepositorySimpleCredentials, setAttribute);
PHP_METHOD(RepositorySimpleCredentials, getAttribute);
PHP_METHOD(RepositorySimpleCredentials, removeAttribute);
PHP_METHOD(RepositorySimpleCredentials, getAttributeNames);
PHP_METHOD(RepositoryTraversingItemVisitor, __construct);
PHP_METHOD(RepositoryTraversingItemVisitor, visit);

#define CRAPI_NODE_ADDED		1
#define CRAPI_NODE_REMOVED		2
#define CRAPI_PROPERTY_ADDED	4
#define CRAPI_PROPERTY_REMOVED	8
#define CRAPI_PROPERTY_CHANGED	16

#define CRAPI_COPY			1
#define CRAPI_VERSION		2
#define CRAPI_INITIALIZE	3
#define CRAPI_COMPUTE		4
#define CRAPI_IGNORE		5
#define CRAPI_ABORT			6
#define CRAPI_ACTIONNAME_COPY		"COPY"
#define CRAPI_ACTIONNAME_VERSION	"VERSION"
#define CRAPI_ACTIONNAME_INITIALIZE	"INITIALIZE"
#define CRAPI_ACTIONNAME_COMPUTE	"COMPUTE"
#define CRAPI_ACTIONNAME_IGNORE		"IGNORE"
#define CRAPI_ACTIONNAME_ABORT		"ABORT"

#define CRAPI_STRING	1
#define CRAPI_BINARY	2
#define CRAPI_LONG		3
#define CRAPI_DOUBLE	4
#define CRAPI_DATE		5
#define CRAPI_BOOLEAN	6
#define CRAPI_NAME		7
#define CRAPI_PATH		8
#define CRAPI_REFERENCE	9
#define CRAPI_UNDEFINED	0
#define CRAPI_TYPENAME_STRING		"String"
#define CRAPI_TYPENAME_BINARY		"Binary"
#define CRAPI_TYPENAME_LONG			"Long"
#define CRAPI_TYPENAME_DOUBLE		"Double"
#define CRAPI_TYPENAME_DATE			"Date"
#define CRAPI_TYPENAME_BOOLEAN		"Boolean"
#define CRAPI_TYPENAME_NAME			"Name"
#define CRAPI_TYPENAME_PATH			"Path"
#define CRAPI_TYPENAME_REFERENCE	"Reference"
#define CRAPI_TYPENAME_UNDEFINED	"undefined"

#define CRAPI_XPATH	"xpath"
#define CRAPI_SQL	"sql"

#define CRAPI_SPEC_VERSION_DESC				"jcr.specification.version"
#define CRAPI_SPEC_NAME_DESC				"jcr.specification.name"
#define CRAPI_REP_VENDOR_DESC				"jcr.repository.vendor"
#define CRAPI_REP_VENDOR_URL_DESC			"jcr.repository.vendor.url"
#define CRAPI_REP_NAME_DESC					"jcr.repository.name"
#define CRAPI_REP_VERSION_DESC				"jcr.repository.version"
#define CRAPI_LEVEL_1_SUPPORTED				"level.1.supported"
#define CRAPI_LEVEL_2_SUPPORTED				"level.2.supported"
#define CRAPI_OPTION_TRANSACTIONS_SUPPORTED	"option.transactions.supported"
#define CRAPI_OPTION_VERSIONING_SUPPORTED	"option.versioning.supported"
#define CRAPI_OPTION_OBSERVATION_SUPPORTED	"option.observation.supported"
#define CRAPI_OPTION_LOCKING_SUPPORTED		"option.locking.supported"
#define CRAPI_OPTION_QUERY_SQL_SUPPORTED	"option.query.sql.supported"
#define CRAPI_QUERY_XPATH_POS_INDEX			"query.xpath.pos.index"
#define CRAPI_QUERY_XPATH_DOC_ORDER			"query.xpath.doc.order"
#define CRAPI_QUERY_JCRPATH					"query.jcrpath"
#define CRAPI_QUERY_JCRSCORE				"query.jcrscore"

#define CRAPI_IMPORT_UUID_CREATE_NEW					0
#define CRAPI_IMPORT_UUID_COLLISION_REMOVE_EXISTING		1
#define CRAPI_IMPORT_UUID_COLLISION_REPLACE_EXISTING	2
#define CRAPI_IMPORT_UUID_COLLISION_THROW				3

#endif	/* PHP_CRAPI_H */

/*
 * Local variables:
 * tab-width: 4
 * c-basic-offset: 4
 * End:
 * vim600: noet sw=4 ts=4 fdm=marker
 * vim<600: noet sw=4 ts=4
 */
